import{s as Q,o as X,n as Y}from"../chunks/scheduler.9bc65507.js";import{S as ee,i as te,g as f,s as l,r as j,A as re,h as c,f as r,c as p,j as I,u as q,x as S,k as V,y as v,a as n,v as A,d as E,t as U,w as R}from"../chunks/index.707bf1b6.js";import{T as ae}from"../chunks/Tip.c2ecdbf4.js";import{D as ne}from"../chunks/Docstring.17db21ae.js";import{H as K}from"../chunks/Heading.342b1fa6.js";function se(H){let a,m='Learn more about using DeepSpeed with <a href="/docs/transformers/v4.38.0/en/main_classes/trainer#transformers.Trainer">Trainer</a> in the <a href="../deepspeed">DeepSpeed</a> guide.';return{c(){a=f("p"),a.innerHTML=m},l(i){a=c(i,"P",{"data-svelte-h":!0}),S(a)!=="svelte-dtb5vp"&&(a.innerHTML=m)},m(i,b){n(i,a,b)},p:Y,d(i){i&&r(a)}}}function ie(H){let a,m,i,b,g,C,u,N='<a href="https://github.com/microsoft/DeepSpeed" rel="nofollow">DeepSpeed</a>, powered by Zero Redundancy Optimizer (ZeRO), is an optimization library for training and fitting very large models onto a GPU. It is available in several ZeRO stages, where each stage progressively saves more GPU memory by partitioning the optimizer state, gradients, parameters, and enabling offloading to a CPU or NVMe. DeepSpeed is integrated with the <a href="/docs/transformers/v4.38.0/en/main_classes/trainer#transformers.Trainer">Trainer</a> class and most of the setup is automatically taken care of for you.',x,h,W='However, if you want to use DeepSpeed without the <a href="/docs/transformers/v4.38.0/en/main_classes/trainer#transformers.Trainer">Trainer</a>, Transformers provides a <code>HfDeepSpeedConfig</code> class.',P,d,L,_,M,s,$,O,T,B="This object contains a DeepSpeed configuration dictionary and can be quickly queried for things like zero stage.",Z,D,F=`A <code>weakref</code> of this object is stored in the module’s globals to be able to access the config from areas where
things like the Trainer object is not available (e.g. <code>from_pretrained</code> and <code>_get_resized_embeddings</code>). Therefore
it’s important that this object remains alive while the program is still running.`,G,w,J=`<a href="/docs/transformers/v4.38.0/en/main_classes/trainer#transformers.Trainer">Trainer</a> uses the <code>HfTrainerDeepSpeedConfig</code> subclass instead. That subclass has logic to sync the configuration
with values of <a href="/docs/transformers/v4.38.0/en/main_classes/trainer#transformers.TrainingArguments">TrainingArguments</a> by replacing special placeholder values: <code>&quot;auto&quot;</code>. Without this special logic
the DeepSpeed configuration is not modified in any way.`,k,y,z;return g=new K({props:{title:"DeepSpeed",local:"deepspeed",headingTag:"h1"}}),d=new ae({props:{$$slots:{default:[se]},$$scope:{ctx:H}}}),_=new K({props:{title:"HfDeepSpeedConfig",local:"transformers.integrations.HfDeepSpeedConfig",headingTag:"h2"}}),$=new ne({props:{name:"class transformers.integrations.HfDeepSpeedConfig",anchor:"transformers.integrations.HfDeepSpeedConfig",parameters:[{name:"config_file_or_dict",val:""}],parametersDescription:[{anchor:"transformers.integrations.HfDeepSpeedConfig.config_file_or_dict",description:"<strong>config_file_or_dict</strong> (<code>Union[str, Dict]</code>) &#x2014; path to DeepSpeed config file or dict.",name:"config_file_or_dict"}],source:"https://github.com/huggingface/transformers/blob/v4.38.0/src/transformers/integrations/deepspeed.py#L55"}}),{c(){a=f("meta"),m=l(),i=f("p"),b=l(),j(g.$$.fragment),C=l(),u=f("p"),u.innerHTML=N,x=l(),h=f("p"),h.innerHTML=W,P=l(),j(d.$$.fragment),L=l(),j(_.$$.fragment),M=l(),s=f("div"),j($.$$.fragment),O=l(),T=f("p"),T.textContent=B,Z=l(),D=f("p"),D.innerHTML=F,G=l(),w=f("p"),w.innerHTML=J,k=l(),y=f("p"),this.h()},l(e){const t=re("svelte-u9bgzb",document.head);a=c(t,"META",{name:!0,content:!0}),t.forEach(r),m=p(e),i=c(e,"P",{}),I(i).forEach(r),b=p(e),q(g.$$.fragment,e),C=p(e),u=c(e,"P",{"data-svelte-h":!0}),S(u)!=="svelte-9sba6u"&&(u.innerHTML=N),x=p(e),h=c(e,"P",{"data-svelte-h":!0}),S(h)!=="svelte-1p48awt"&&(h.innerHTML=W),P=p(e),q(d.$$.fragment,e),L=p(e),q(_.$$.fragment,e),M=p(e),s=c(e,"DIV",{class:!0});var o=I(s);q($.$$.fragment,o),O=p(o),T=c(o,"P",{"data-svelte-h":!0}),S(T)!=="svelte-g6t8ro"&&(T.textContent=B),Z=p(o),D=c(o,"P",{"data-svelte-h":!0}),S(D)!=="svelte-xzx2jk"&&(D.innerHTML=F),G=p(o),w=c(o,"P",{"data-svelte-h":!0}),S(w)!=="svelte-rrkwsy"&&(w.innerHTML=J),o.forEach(r),k=p(e),y=c(e,"P",{}),I(y).forEach(r),this.h()},h(){V(a,"name","hf:doc:metadata"),V(a,"content",oe),V(s,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8")},m(e,t){v(document.head,a),n(e,m,t),n(e,i,t),n(e,b,t),A(g,e,t),n(e,C,t),n(e,u,t),n(e,x,t),n(e,h,t),n(e,P,t),A(d,e,t),n(e,L,t),A(_,e,t),n(e,M,t),n(e,s,t),A($,s,null),v(s,O),v(s,T),v(s,Z),v(s,D),v(s,G),v(s,w),n(e,k,t),n(e,y,t),z=!0},p(e,[t]){const o={};t&2&&(o.$$scope={dirty:t,ctx:e}),d.$set(o)},i(e){z||(E(g.$$.fragment,e),E(d.$$.fragment,e),E(_.$$.fragment,e),E($.$$.fragment,e),z=!0)},o(e){U(g.$$.fragment,e),U(d.$$.fragment,e),U(_.$$.fragment,e),U($.$$.fragment,e),z=!1},d(e){e&&(r(m),r(i),r(b),r(C),r(u),r(x),r(h),r(P),r(L),r(M),r(s),r(k),r(y)),r(a),R(g,e),R(d,e),R(_,e),R($)}}}const oe='{"title":"DeepSpeed","local":"deepspeed","sections":[{"title":"HfDeepSpeedConfig","local":"transformers.integrations.HfDeepSpeedConfig","sections":[],"depth":2}],"depth":1}';function le(H){return X(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class ge extends ee{constructor(a){super(),te(this,a,le,ie,Q,{})}}export{ge as component};
